//
//  VMCategories.h
//  VMobSDK
//
//  Created by vmob.co on 7/23/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import <Foundation/Foundation.h>

/**
 `VMCategories` is a categories class
 */
@interface VMCategories : NSObject

/**
 ID of the category.
 */
@property (nonatomic, strong) NSNumber *uid;

/**
 Name of the Category.
 */
@property (nonatomic, strong) NSString *name;

/**
 sortOrder applied for the category.
 */
@property (nonatomic, strong) NSNumber *sortOrder;

/**
 Hi-resolution image for the category.
 */
@property (nonatomic, strong) NSString *highResolutionImage;

/**
 Hi-resolution Selected Image for the category.
 */
@property (nonatomic, strong) NSString *highResolutionSelectedImage;

/**
 Low-resolution Image for the category.
 */
@property (nonatomic, strong) NSString *lowResolutionImage;

/**
 Low-resolution Selected Image for the category.
 */
@property (nonatomic, strong) NSString *lowResolutionSelectedImage;

/**
 Initialize new `VMCategories` object with dictionary representation.
 
 @param dicitionary Initializing dictionary.
 
 @return A new Category object.
 */
- (VMCategories *) initWithDictionary: (NSDictionary *) dictionary;

@end
