//
//  AcivityViewController.m
//  SampleVMSDK
//
//  Created by vmob.co on 5/28/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "ActivityViewController.h"
#import "VMActivityManager.h"
#import "VMConsumerManager.h"

@interface ActivityViewController ()
@property (weak, nonatomic) IBOutlet UILabel *lastSendLabel;
@property (weak, nonatomic) IBOutlet UITextView *currentActivityTextView;
@property (nonatomic, weak) VMHTTPRequestOperation *currentOperation;
@end

@implementation ActivityViewController

- (void)viewDidLoad {
	[super viewDidLoad];
	self.title = @"Activity API";
	self.lastSendLabel.text = [NSString stringWithFormat:@"%@",[[VMActivityManager sharedInstance] lastSendStack]];
	self.currentActivityTextView.text = [NSString stringWithFormat:@"%@", [[VMActivityManager sharedInstance] stackActivity]];
	
	[[VMActivityManager sharedInstance] setUpdateDate:^(NSDate *description) {
		self.lastSendLabel.text = [NSString stringWithFormat:@"%@", description];
	}];
	[[VMActivityManager sharedInstance] setUpdateStackActivity:^(NSArray *description) {
		self.currentActivityTextView.text = [NSString stringWithFormat:@"%@", description];
	}];
}

#pragma mark - Action methods

- (IBAction)addedActivityButtonAction:(id)sender {
	for(NSInteger i = 0; i <=3; i++) {
		[self addActivity:i];
	}
}

- (IBAction)sendLogButtonAction:(id)sender {
	self.currentOperation = [[VMActivityManager sharedInstance] sendHistoryActivityWithUserToken:[VMConsumerManager sharedInstance].userToken completionBlock:^{
		
	} failBlock:^(NSError *error) {
		
	}];
}

- (IBAction)cancelRequestButtonAction:(id)sender {
	[self.currentOperation cancel];
}

#pragma mark - Private Methods

- (void) addActivity: (NSInteger) indexMethods {
	switch (indexMethods) {
		case 0:
			[[VMActivityManager sharedInstance] appStartup];
			break;
		case 1:
			[[VMActivityManager sharedInstance] registrationWithRegistrationType:VMAEmail];
			break;
		case 2:
			[[VMActivityManager sharedInstance] offerShareWithSocialType:VMSEmail offerId:@"1438"];
			break;
		case 3:
			[[VMActivityManager sharedInstance] buttonClickWithButtonId:@"Button ID" merchantId:@"546" venueId:@"2315" itemId:@"1438" itemCode:@"O"];
			break;
		default:
			break;
	}
}

- (void)viewDidUnload {
	[self setCurrentActivityTextView:nil];
	[self setLastSendLabel:nil];
	[super viewDidUnload];
}
@end
