//
//  LocationViewController.m
//  SampleVMSDK
//
//  Created by vmob.co on 6/3/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "LocationViewController.h"
#import "VMLocationsManager.h"

@interface LocationViewController ()
@property (weak, nonatomic) IBOutlet UITextView *infoLocationTextView;
@property (nonatomic, strong) NSMutableArray *messages;
@end

@implementation LocationViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.title = @"Location API";
	self.messages = [NSMutableArray array];
	[self.messages addObject:[NSString stringWithFormat:@"Update Location TimeInterval - %f", [VMLocationsManager sharedInstance].updateLocationTimeInterval]];
	self.infoLocationTextView.text = [NSString stringWithFormat:@"%@", self.messages];
	[[VMLocationsManager sharedInstance] setUpdateActivityLocation:^(CLLocation *location) {
		[self.messages addObject:[NSString stringWithFormat:@"Update Activity Location %@", location]];
		self.infoLocationTextView.text = [NSString stringWithFormat:@"%@", self.messages];
	}];
}

#pragma mark - Action Methods

- (IBAction)statesListButtonAction:(UIButton *)sender {
	[[VMLocationsManager sharedInstance] statesListWithCompletionBlock:^(id description) {
		[[[UIAlertView alloc] initWithTitle:@"Completion statesList" message:[NSString stringWithFormat:@"%@",description] delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
	} failBlock:^(NSError *error) {
		[[[UIAlertView alloc] initWithTitle:@"Fail stateList" message:[error localizedDescription] delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
	}];
}

- (IBAction)citiesListButtonAction:(UIButton *)sender {
	[[VMLocationsManager sharedInstance] citiesListWithCompletionBlock:^(id description) {
		[[[UIAlertView alloc] initWithTitle:@"Completion citiesList" message:[NSString stringWithFormat:@"%@",description] delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
	} failBlock:^(NSError *error) {
		[[[UIAlertView alloc] initWithTitle:@"Fail citiesList" message:[error localizedDescription] delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
	}];
}

- (IBAction)controlUpdateLocationButtonAction:(UIButton *)sender {
	NSString *title = nil;
	if ([VMLocationsManager sharedInstance].isUpdatingLocation) {
		title = @"Start Updating Location";
		[[VMLocationsManager sharedInstance] stopLocation];
		
	}
	else {
		title = @"Stop Updating Location";
		[[VMLocationsManager sharedInstance] startLocationWithCompletionBlock:^(CLLocation *location) {
			[self.messages addObject:[NSString stringWithFormat:@"Update location %@", location]];
			self.infoLocationTextView.text = [NSString stringWithFormat:@"%@", self.messages];
		} failBlock:^(NSError *error) {
			[self.messages addObject:[NSString stringWithFormat:@"Error %@", error]];
			self.infoLocationTextView.text = [NSString stringWithFormat:@"%@", self.messages];
		}];
	}
	[sender setTitle:title forState:UIControlStateNormal];
}


- (void)viewDidUnload {
	[self setInfoLocationTextView:nil];
	[super viewDidUnload];
}
@end
