//
//  OfferViewController.m
//  SampleVMSDK
//
//  Created by vmob.co on 6/1/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "OfferViewController.h"
#import "VMOfferManager.h"
#import "VMConsumerManager.h"

@interface OfferViewController ()

@end

@implementation OfferViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    self.title = @"Offer API";
}

#pragma mark - Action Methods

- (IBAction)merchantListButtonAction:(UIButton *)sender {
	[[VMOfferManager sharedInstance] merchantListWithUserToken:[VMConsumerManager sharedInstance].userToken
													categoryId:@"1"
														offset:@"0"
														 limit:@"100"
											   completionBlock:^(NSDictionary *description) {
												   [[[UIAlertView alloc] initWithTitle:@"Completion merchantList" message:[NSString stringWithFormat:@"%@",description] delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
											   }
													 failBlock:^(NSError *error) {
														 [[[UIAlertView alloc] initWithTitle:@"Fail merchantList" message:[error localizedDescription] delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
													 }];
}

- (IBAction)categoriesListButtonAction:(id)sender {
	[[VMOfferManager sharedInstance] categoriesOfferWithUserToken:[VMConsumerManager sharedInstance].userToken
								includeConsumerExcludedCategories:NO
												  completionBlock:^(NSDictionary *description) {
													  [[[UIAlertView alloc] initWithTitle:@"Completion categoriesList" message:[NSString stringWithFormat:@"%@",description] delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
												  }
														failBlock:^(NSError *error) {
															[[[UIAlertView alloc] initWithTitle:@"Fail categoriesList" message:[error localizedDescription] delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
														}];
}

- (IBAction)nearbyOffersButtonAction:(id)sender {
	[[VMOfferManager sharedInstance] nearbyOffersWithUserToken:[VMConsumerManager sharedInstance].userToken
													  latitude:@"52.3"
													 longitude:@"4.5"
													categoryId:@"1"
														offset:@"0"
														 limit:@"100"
														fields:nil
											   completionBlock:^(id description) {
												   [[[UIAlertView alloc] initWithTitle:@"Completion nearbyOffers" message:[NSString stringWithFormat:@"%@",description] delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
											   }
													 failBlock:^(NSError *error) {
														 [[[UIAlertView alloc] initWithTitle:@"Fail nearbyOffers" message:[error localizedDescription] delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
													 }];
}

- (IBAction)searchOffersButtonAction:(id)sender {
	[[VMOfferManager sharedInstance] searchOffersWithUserToken:[VMConsumerManager sharedInstance].userToken
												  rankedSearch:NO
													   keyword:nil
													categoryId:nil
													merchantId:nil
														fields:nil
													   orderBy:nil
													 ascending:YES
											   completionBlock:^(id description) {
												   [[[UIAlertView alloc] initWithTitle:@"Completion searchOffers" message:[NSString stringWithFormat:@"%@",description] delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
											   }
													 failBlock:^(NSError *error) {
														 [[[UIAlertView alloc] initWithTitle:@"Fail searchOffers" message:[error localizedDescription] delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
													 }];
}

- (IBAction)termsButtonAction:(id)sender {
    [[VMOfferManager sharedInstance] termsAndConditionsWithUserToken:[VMConsumerManager sharedInstance].userToken
                                                             offerId:@"100"
                                                     completionBlock:^(id description) {
                                                         [[[UIAlertView alloc] initWithTitle:@"Offer terms" message:[NSString stringWithFormat:@"%@",description] delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
                                                         
                                                     } failBlock:^(NSError *error) {
                                                         [[[UIAlertView alloc] initWithTitle:@"Fail terms" message:[error localizedDescription] delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
                                                     }];
}
@end
