//
//  ConfigurationViewController.m
//  SampleVMSDK
//
//  Created by vmob.co on 7/23/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "ConfigurationViewController.h"
#import "VMConfigurationManager.h"

@interface ConfigurationViewController ()
@property (weak, nonatomic) IBOutlet UITextView *configurationTextView;
@property (weak, nonatomic) IBOutlet UITextField *configurationApiUrlTextField;
@property (weak, nonatomic) IBOutlet UITextField *activityApiUrlTextField;
@property (weak, nonatomic) IBOutlet UITextField *consumerApiUrlTextField;
@property (weak, nonatomic) IBOutlet UITextField *locationApiUrlTextField;
@property (weak, nonatomic) IBOutlet UITextField *offerApiUrlTextField;

@end

@implementation ConfigurationViewController

-(void)viewDidLoad {
	[super viewDidLoad];
	[self updateData];
}

- (IBAction)updateConfiguration:(UIButton *)sender {
	[[VMConfigurationManager sharedInstance] updateConfigurationWithCompletionBlock:^(id description) {
		[self updateData];
	} failBlock:^(NSError *error) {
		[self updateData];
	}];
}

- (void) updateData {
	self.configurationTextView.text = [NSString stringWithFormat:@"%@", [VMConfigurationManager lastConfiguration]];
	self.configurationApiUrlTextField.text = [VMConfigurationManager configurationApiUrl];
	self.activityApiUrlTextField.text = [VMConfigurationManager activityApiUrl];
	self.consumerApiUrlTextField.text = [VMConfigurationManager consumerApiUrl];
	self.locationApiUrlTextField.text = [VMConfigurationManager locationApiUrl];
	self.offerApiUrlTextField.text = [VMConfigurationManager offerApiUrl];
}

@end
