//
//  ManagerConsumerViewController.m
//  SampleVMSDK
//
//  Created by vmob.co on 5/31/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "ManagerConsumerViewController.h"
#import "VMConsumerManager.h"

@interface ManagerConsumerViewController ()
@property (nonatomic, strong) VMConsumer *consumer;
@end

@implementation ManagerConsumerViewController

- (void)viewDidLoad {
	[super viewDidLoad];
	self.title = @"Manager Consumer";
}

- (IBAction)consumerDetailButtonAction:(UIButton *)sender {
	[[VMConsumerManager sharedInstance] detailConsumerWithUserToken:[VMConsumerManager sharedInstance].userToken
													completionBlock:^(NSDictionary *description) {
														self.consumer = [[VMConsumer alloc] initWithDictionary:description];
														[[[UIAlertView alloc] initWithTitle:@"ConsumerDetail Complition" message:[NSString stringWithFormat:@"%@", description]
																				   delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
													}
														  failBlock:^(NSError *error) {
															  [[[UIAlertView alloc] initWithTitle:@"ConsumerDetail Fail" message:[error localizedDescription]
																						 delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
														  }];
}

- (IBAction)consumerUpdateButtonAction:(UIButton *)sender {
	[[VMConsumerManager sharedInstance] updateConsumerWithUserToken:[VMConsumerManager sharedInstance].userToken
														  firstName:@"Update First"
														   lastName:@"Update lastName"
														   fullName:@"Update fullName"
															 gender:VMMale
														dateOfBirth:[NSDate date]
															   city:@"4"
                                                       emailAddress:@"Update@email.com"
													completionBlock:^(NSDictionary *description) {
														[[[UIAlertView alloc] initWithTitle:@"ConsumerUpdate Complition" message:[NSString stringWithFormat:@"%@", description]
																				   delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
													}
														  failBlock:^(NSError *error) {
															  [[[UIAlertView alloc] initWithTitle:@"ConsumerUpdate Fail" message:[error localizedDescription]
																						 delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
														  }];
}

- (IBAction)listRedeemOfferButtonAction:(UIButton *)sender {
	[[VMConsumerManager sharedInstance] listRedeemedOffersWithUserToken:[VMConsumerManager sharedInstance].userToken
														completionBlock:^(NSDictionary *description) {
															[[[UIAlertView alloc] initWithTitle:@"ConsumerUpdate Complition" message:[NSString stringWithFormat:@"%@", description]
																					   delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
														}
															  failBlock:^(NSError *error) {
																  [[[UIAlertView alloc] initWithTitle:@"ConsumerUpdate Fail" message:[error localizedDescription]
																							 delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
															  }];
}

- (IBAction)listTagButtonAction:(UIButton *)sender {
	[[VMConsumerManager sharedInstance] listTagWithUserToken:[VMConsumerManager sharedInstance].userToken
											 completionBlock:^(NSDictionary *description) {
												 [[[UIAlertView alloc] initWithTitle:@"ListTag Complition" message:[NSString stringWithFormat:@"%@", description]
																			delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
											 }
												   failBlock:^(NSError *error) {
													   [[[UIAlertView alloc] initWithTitle:@"ListTag Fail" message:[error localizedDescription]
																				  delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
												   }];

}

- (IBAction)addTagsButtonAction:(UIButton *)sender {
	[[VMConsumerManager sharedInstance] addTagsWithUserToken:[VMConsumerManager sharedInstance].userToken
									  completionBlock:^(NSDictionary *description) {
										  [[[UIAlertView alloc] initWithTitle:@"AddTags Complition" message:[NSString stringWithFormat:@"%@", description]
																	 delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
									  }
											failBlock:^(NSError *error) {
												[[[UIAlertView alloc] initWithTitle:@"AddTags Fail" message:[error localizedDescription]
																		   delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
											}
							   tagValueReferenceCodes:@"product-101", @"product-50", @"product-85", nil];
}

- (IBAction)removeTagsButtonAction:(UIButton *)sender {
	[[VMConsumerManager sharedInstance] removeTagsWithUserToken:[VMConsumerManager sharedInstance].userToken
											 completionBlock:^(NSDictionary *description) {
												 [[[UIAlertView alloc] initWithTitle:@"RemoveTags Complition" message:[NSString stringWithFormat:@"%@", description]
																			delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
											 }
												   failBlock:^(NSError *error) {
													   [[[UIAlertView alloc] initWithTitle:@"RemoveTags Fail" message:[error localizedDescription]
																				  delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
												   }
									  tagValueReferenceCodes:@"product-101", @"product-50", @"product-85", @"product-100", @"product-51", @"product-86", nil];
}

- (IBAction)updateTagsButtonAction:(UIButton *)sender {
    [[VMConsumerManager sharedInstance] updateTagWithUserToken:[VMConsumerManager sharedInstance].userToken
                                     tagValueAddReferenceCodes:[NSArray arrayWithObjects:@"product-100", @"product-51", @"product-86", nil]
                                  tagValueRemoveReferenceCodes:[NSArray arrayWithObjects:@"product-101", @"product-50", @"product-85", nil]
                                               completionBlock:^(NSDictionary *description) {
                                                   [[[UIAlertView alloc] initWithTitle:@"UpdateTags Complition" message:[NSString stringWithFormat:@"%@", description]
                                                                              delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
                                               }
                                                     failBlock:^(NSError *error) {
                                                         [[[UIAlertView alloc] initWithTitle:@"UpdateTags Fail" message:[error localizedDescription]
                                                                                    delegate:nil cancelButtonTitle:@"Ok" otherButtonTitles:nil] show];
                                                     }];
}

@end
