//
//  UIApplication+VMRuntime.m
//  VMobSDK
//
//  Created by vmob.co on 8/9/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "UIApplication+VMRuntime.h"
#import <objc/runtime.h>
#import "VMConfigurationManager.h"
#import "VMLocationsManager.h"
#import "VMUtils.h"

@implementation UIApplication (VMRuntime)

static void swizze(Class class, SEL fromChange, SEL toChange, IMP impl, const char * signature)
{
	Method method = nil;
	method = class_getInstanceMethod(class, fromChange);
	
	if (method) {
		//method exists add a new method and swap with original
		class_addMethod(class, toChange, impl, signature);
		method_exchangeImplementations(class_getInstanceMethod(class, fromChange), class_getInstanceMethod(class, toChange));
	} else {
		//just add as orignal method
		class_addMethod(class, fromChange, impl, signature);
	}
}

void VMApplicationDidBecomeActive(id self, SEL _cmd, id application) {
	
	//init Location: configuration is updated from the API data
	if ([VMUtils isUpdateConfiguration]) {
		[[VMConfigurationManager sharedInstance] updateConfigurationWithCompletionBlock:^(id description) {
			[VMLocationsManager sharedInstance];	// initializing location manager
		} failBlock:^(NSError *error) {
			[VMLocationsManager sharedInstance];	// initializing location manager
		}];
	}
	else {
		[VMLocationsManager sharedInstance];	// initializing location manager
	}
	
	
	if ([self respondsToSelector:@selector(vm_applicationDidBecomeActive:)]) {
		[self vm_applicationDidBecomeActive:application];
	}
}

- (void) vm_setDelegate:(id<UIApplicationDelegate>)delegate
{    
    if ([VMUtils addCodeForAutoConfgurationUpdate])
    {
        swizze([delegate class], @selector(applicationDidBecomeActive:), @selector(vm_applicationDidBecomeActive:), (IMP)VMApplicationDidBecomeActive, "v@::");
    }
    
	[self vm_setDelegate:delegate];
}

+ (void) load {
	method_exchangeImplementations(class_getInstanceMethod(self, @selector(setDelegate:)), class_getInstanceMethod(self, @selector(vm_setDelegate:)));
	NSLog(@"VMob loaded");
}

@end
