//
//  NSDictionary+ServiceHelper.m
//  AMToolkit
//
//  Created by Anton Kaizer on 25.02.13.
//  Copyright (c) 2013 Arello Mobile. All rights reserved.
//

#import "NSDictionary+VMServiceHelper.h"
#import "NSDate+VMAdditions.h"

@implementation NSDictionary (VMServiceHelper)

- (NSDate *) parseDateFromStringWithKey:(NSString *) key withFormat:(NSString *) format {
	NSString *stringValue = [self validObjectForKey:key];
	if (stringValue)
		return [NSDate dateFromString:[self validObjectForKey:key] withFormat:format];
	return nil;
}

- (NSArray *) parseObjectsArrayFromArrayWithKey:(NSString *) key withClass:(Class) itemClass {
	if (![itemClass instancesRespondToSelector:@selector(initWithDictionary:)])
		[NSException raise:NSInvalidArgumentException format:@"%@ not respond to initWithDictionary", itemClass];
	
	NSMutableArray *result = [NSMutableArray array];
	NSArray *objectsArray = [self validObjectForKey:key];
	for (NSDictionary *objDict in objectsArray) {
		[result addObject:[[itemClass alloc] initWithDictionary:objDict]];
	}
	return result;
}

@end
