//
//  ServiceProvider.h
//  asdasdasd
//
//  Created by Anton Kaizer on 04.02.13.
//  Copyright (c) 2013 Arello Mobile. All rights reserved.
//

#import "VMBaseRequest.h"
#import "VMRequestError.h"
#import "VMNetworking.h"
#import "VMFileRequest.h"

typedef void (^RequestSuccessCallback)(id request);
typedef void (^RequestFailCallback)(id request, NSError *requestError);

@interface VMHTTPProvider : VMHTTPClient

@property (nonatomic, copy) NSString *requestEnvelope;
@property (nonatomic, copy) NSString *responseKey;
@property (nonatomic, copy) NSString *autorizationToken;
@property (nonatomic) BOOL enableLogging;

- (VMHTTPRequestOperation *) sendRequest:(VMBaseRequest *) serviceRequest toPath:(NSString *) path success:(RequestSuccessCallback) success failure:(RequestFailCallback) failure;
- (VMHTTPRequestOperation *) sendRequest:(VMBaseRequest *) serviceRequest success:(RequestSuccessCallback) success failure:(RequestFailCallback) failure;
+ (instancetype) sharedProvider;

- (VMHTTPRequestOperation *) uploadFileWithRequest:(VMFileRequest *) fileRequest success:(RequestSuccessCallback) success failure:(RequestFailCallback) failure;
- (VMHTTPRequestOperation *) downloadFileWithRequest:(VMFileRequest *) fileRequest success:(RequestSuccessCallback) success failure:(RequestFailCallback) failure;


//can be overrided in subclasses
-  (VMHTTPRequestOperation *) HTTPRequestOperationWithRequest:(NSMutableURLRequest *) request serviceRequest:(VMServiceRequest *) serviceRequest success:(RequestSuccessCallback) success failure:(RequestFailCallback) failure;
- (void) registerOperationClasses;
- (void) requestWillSend:(NSMutableURLRequest *) request;

@end
