//
//  AMJSONRequestOperation.m
//  PullToRefreshSample
//
//  Created by Anton Kaizer on 11.02.13.
//  Copyright (c) 2013 Arello Mobile. All rights reserved.
//

#import "VMJSRequestOperation.h"
#import "AMHTTPStatusCodes.h"
#import "NSDictionary+VMValidation.h"
#import "NSString+VMAdditions.h"

@interface VMJSRequestOperation ()

@property (readwrite, nonatomic, strong) NSHTTPURLResponse *response;
@property (nonatomic, strong) NSError *contentTypeError;

@end

@implementation VMJSRequestOperation

#pragma mark - VMHTTPRequestOperation

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response {
	if ([response isKindOfClass:[NSHTTPURLResponse class]] ) {
		self.response = (NSHTTPURLResponse *)response;
		if ([self.responseData length] == 0 || [self hasAcceptableContentType]) {
			[super connection:connection didReceiveResponse:response];
		} else {
			NSMutableDictionary *userInfo = [NSMutableDictionary dictionary];
			[userInfo setValue:[NSString stringWithFormat:NSLocalizedString(@"Expected content type %@, got %@", nil), [[self class] acceptableContentTypes], [self.response MIMEType]] forKey:NSLocalizedDescriptionKey];
			self.contentTypeError = [[NSError alloc] initWithDomain:VMNetworkingErrorDomain code:NSURLErrorCannotDecodeContentData userInfo:userInfo];
			[connection cancel];
			[super connectionDidFinishLoading:connection];
        }
	}
}

- (NSError *) error {
	if (self.contentTypeError)
		return self.contentTypeError;
	else
		return [super error];
}

@end
