/*
 * Arello Mobile
 * Mobile Framework
 * Except where otherwise noted, this work is licensed under a Creative Commons Attribution 3.0 Unported License
 * http://creativecommons.org/licenses/by/3.0
 */

#import "VMServiceRequest.h"
#import "NSString+VMValidation.h"
#import "NSDictionary+VMValidation.h"

@implementation VMServiceRequest;

- (NSString *) acceptableContentType {
	return @"application/json";
}

- (NSString *) method {
	return @"POST";
}

- (NSString *) path {
	return @"(request_path_here)";
}

- (NSDictionary *) requestDictionary {
	return [NSDictionary dictionary];
}

- (void) processResponse: (NSObject *) response {
	
}

- (VMRequestError *) validateResponse:(NSDictionary*) responseDictionary httpResponse:(NSHTTPURLResponse *) httpResponse {
	if (httpResponse.statusCode != HTTP_OK && httpResponse.statusCode != HTTP_CREATED && httpResponse.statusCode != HTTP_ACCEPTED && !httpResponse.statusCode == HTTP_NO_CONTENT) {
		NSString *errorMessage = [responseDictionary objectForKey:@"error"];
		if (errorMessage)
			return [VMRequestError requestErrorWithCode:httpResponse.statusCode description:errorMessage];
		else
			return [VMRequestError requestErrorWithCode:httpResponse.statusCode description:@"Some server error occured."];
	}
	
	return nil;
}

@end