//
//  ActivitiesRequest.m
//  VMobSDK
//
//  Created by vmob.co on 5/30/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "VMActivitiesRequest.h"
#import "NSDictionary+VMValidation.h"
#import "VMUtils.h"
#import "NSString+VMToolkitAdditions.h"

@interface VMActivitiesRequest ()

@property (nonatomic, strong) NSMutableDictionary *dictionaryHeader;
@property (nonatomic, strong) NSString *path;
@property (nonatomic, strong) NSDictionary *requestDictionary;

@end

@implementation VMActivitiesRequest

- (VMActivitiesRequest *) initWithUserToken: (NSString *) token
							 bodyActivities: (NSArray *) activities {
	
	if (self = [super init]) {
		self.sentStackActivity = activities;
		self.dictionaryHeader = [super dictionaryHeader];
		[self.dictionaryHeader setObjectOrDoNothing:token forKey:@"Authorization"];
		
		
		self.requestDictionary = @{@"activities": activities};
		
		if (!token) {
			self.path = @"activitiesAnon";
		}
		else {
			self.path = @"activities";
		}
	}
	return self;
}

- (VMActivitiesRequest *) initWithUserToken: (NSString *) token
								   typeCode: (NSString *) typeCode
									   code: (NSString *) code
									 value1: (NSString *) value1
									 value2: (NSString *) value2
									 value3: (NSString *) value3
							   redemptionId: (NSString *) redemptionId
								   latitude: (NSString *) latitude
								  longitude: (NSString *) longitude
									ownerId: (NSString *) ownerId
									  macId: (NSString *) macId
								 merchantId: (NSString *) merchantId
								 campaignId: (NSString *) campaignId
									 itemId: (NSString *) itemId
								   itemCode: (NSString *) itemCode
									venueId: (NSString *) venueId {
	
	if (self = [super init]) {
		self.dictionaryHeader = [super dictionaryHeader];
		[self.dictionaryHeader setObjectOrDoNothing:token forKey:@"Authorization"];
		
		if (!token) {
			self.path = @"activitiesAnon";
		}
		else {
			self.path = @"activities";
		}
		
		NSMutableDictionary *dict = [NSMutableDictionary new];
		
		[dict setObjectOrDoNothing:[NSString stringWithUUID] forKey:@"id"];
		[dict setObjectOrDoNothing:[VMUtils UTCFormateDate:[NSDate date]] forKey:@"sourceActivityTime"];
		[dict setObjectOrDoNothing:[VMUtils offsetUTC] forKey:@"sourceActivityTimeZoneOffset"];

		[dict setObjectOrDoNothing:typeCode forKey:@"actionTypeCode"];
		[dict setObjectOrDoNothing:code forKey:@"actionCode"];
		[dict setObjectOrDoNothing:value1 forKey:@"actionValue1"];
		[dict setObjectOrDoNothing:value2 forKey:@"actionValue2"];
		[dict setObjectOrDoNothing:value3 forKey:@"actionValue3"];
		[dict setObjectOrDoNothing:redemptionId forKey:@"redemptionId"];
		[dict setObjectOrDoNothing:latitude forKey:@"latitude"];
		[dict setObjectOrDoNothing:longitude forKey:@"longitude"];
		[dict setObjectOrDoNothing:ownerId forKey:@"ownerId"];
		[dict setObjectOrDoNothing:macId forKey:@"macId"];
		[dict setObjectOrDoNothing:merchantId forKey:@"merchantId"];
		[dict setObjectOrDoNothing:campaignId forKey:@"campaignId"];
		[dict setObjectOrDoNothing:itemId forKey:@"itemId"];
		[dict setObjectOrDoNothing:itemCode forKey:@"itemCode"];
		[dict setObjectOrDoNothing:venueId forKey:@"venueId"];
		
		self.requestDictionary = @{@"activities": @[dict]};
	}
	return self;
}

@end
