//
//  VMActivity.h
//  VMobSDK
//
//  Created by vmob.co on 7/3/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "VMConstant.h"

@interface VMActivity : NSObject

@property (nonatomic, strong) NSString *actionTypeCode;
@property (nonatomic, strong) NSString *actionCode;
@property (nonatomic, strong) NSString *value1;
@property (nonatomic, strong) NSString *value2;
@property (nonatomic, strong) NSString *value3;
@property (nonatomic, strong) NSString *redemptionId;
@property (nonatomic, strong) NSString *latitude;
@property (nonatomic, strong) NSString *longitude;
@property (nonatomic, strong) NSString *ownerId;
@property (nonatomic, strong) NSString *macId;
@property (nonatomic, strong) NSString *merchantId;
@property (nonatomic, strong) NSString *campaignId;
@property (nonatomic, strong) NSString *itemId;
@property (nonatomic, strong) NSString *itemCode;
@property (nonatomic, strong) NSString *venueId;
@property (nonatomic, strong) NSString *sourceActivityTime;
@property (nonatomic) BOOL isGiftable;
@property (nonatomic) BOOL isAGift;
@property (nonatomic, strong) NSString *GiftedBy;
@property (nonatomic, strong) NSString *GiftedCopy;


- (VMActivity *) initWithDictionary: (NSDictionary *) dict;

#pragma mark - Comparison Methods

+ (BOOL) compareFirstDict: (NSDictionary *) first secondDict: (NSDictionary *) second;

#pragma mark - Validate

+ (BOOL) validateSourceActivityTime: (NSDate *) date;
+ (BOOL) validateActivityWithDictionary: (NSDictionary *) dictionary;

#pragma mark - Universal Dictionary

+ (NSMutableDictionary *) mutableDictionaryWithActionTypeCode: (VMActionTypeCode) actionTypeCode
												   actionCode: (NSString *) actionCode
													   value1: (NSString *) value1
													   value2: (NSString *) value2
													   value3: (NSString *) value3
												 redemptionId: (NSString *) redemptionId
													 latitude: (NSString *) latitude
													longitude: (NSString *) longitude
													  ownerId: (NSString *) ownerId
														macId: (NSString *) macId
												   merchantId: (NSString *) merchantId
												   campaignId: (NSString *) campaignId
													   itemId: (NSString *) itemId
													 itemCode: (NSString *) itemCode
													  venueId: (NSString *) venueId;

#pragma mark - Button Click

+ (NSMutableDictionary *) dictionaryButtonClickAnonymousWithButtonId: (NSString *) buttonId
														  merchantId: (NSString *) merchantId
															 venueId: (NSString *) venueId
															  itemId: (NSString *) itemId
															itemCode: (NSString *) itemCode;

+ (NSMutableDictionary *) dictionaryButtonClickWithButtonId: (NSString *) buttonId
												 merchantId: (NSString *) merchantId
													venueId: (NSString *) venueId
													 itemId: (NSString *) itemId
												   itemCode: (NSString *) itemCode;
#pragma mark - Location Checkin

+ (NSMutableDictionary *) dictionaryLocationCheckinWithTypeGPS: (VMTypeGPS) typeGPS
											  locationAccuracy: (NSString *) locationAccuracy
												 currentCourse: (NSString *) currentCourse
														 speed: (NSString *) speed
													  altitude: (NSString *) altitude
													  latitude: (NSString *) latitude
													 longitude: (NSString *) longitude;

#pragma mark - AppPageImpression

+ (NSMutableDictionary *) dictionaryAppPageImpressionAnonymWithPageId: (NSString *) pageId
														   merchantId: (NSString *) merchantId
															  venueId: (NSString *) venueId
															   itemId: (NSString *) itemId
															 itemCode: (NSString *) itemCode;

+ (NSMutableDictionary *) dictionaryAppPageImpressionWithPageId: (NSString *) pageId
													 merchantId: (NSString *) merchantId
														venueId: (NSString *) venueId
														 itemId: (NSString *) itemId
													   itemCode: (NSString *) itemCode;

#pragma mark - Offer

+ (NSMutableDictionary *) dictionaryOfferImpressionWithPlacementType: (NSString *) placementType
															 offerId: (NSString *) offerId;

+ (NSMutableDictionary *) dictionaryOfferRedemptionWithPlacementType: (NSString *) placementType
													 paymentTypeCode: (NSString *) paymentTypeCode
														   paymentId: (NSString *) paymentId
													   paymentAmount: (NSString *) paymentAmount
													   redeemedOffer: (NSString *) redeemedOffer
															 offerId: (NSString *) offerId
															 venueId: (NSString *) venueId;

+ (NSMutableDictionary *) dictionaryOfferClickThroughWithPlacementType: (NSString *) placementType
															   offerId: (NSString *) offerId;

+ (NSMutableDictionary *) dictionaryOfferInstoreRedemptionWithPlacementType: (NSString *) placementType
															  redeemedOffer: (NSString *) redeemedOffer
																	offerId: (NSString *) offerId
																	venueId: (NSString *) venueId;

#pragma mark - Application

+ (NSMutableDictionary *) dictionaryAppStartup;

+ (NSMutableDictionary *) dictionaryAppStartupAnonym;

+ (NSMutableDictionary *) dictionaryAppInstall;

#pragma mark - Social

+ (NSMutableDictionary *) dictionaryRegistrationWithRegistrationType: (VMActivitySocialType) socialType;

+ (NSMutableDictionary *) dictionaryLoginWithLoginType: (VMActivitySocialType) socialType;

+ (NSMutableDictionary *) dictionaryOfferShareWithSocialType: (VMShareSocialType) socialType
													 offerId: (NSString *) offerId;

#pragma mark - Advertisement

+ (NSMutableDictionary *) dictionaryAdvertisementImpressionWithPlacementCode: (NSString *) placementCode
																 channelCode: (NSString *) channelCode
															 advertisementId: (NSString *) advertisementId;

+ (NSMutableDictionary *) dictionaryAdvertisementClickWithPlacementCode: (NSString *) placementCode
															channelCode: (NSString *) channelCode
														advertisementId: (NSString *) advertisementId;


@end
