//
//  VMBaseRequest.m
//  VMobSDK
//
//  Created by vmob.co on 5/29/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "VMBaseRequest.h"
#import "NSString+VMAdditions.h"
#import "NSDictionary+VMValidation.h"
#import "VMUtils.h"
#import "VMLocationsManager.h"
#import "NSString+VMValidation.h"

@implementation VMBaseRequest

- (NSMutableDictionary *) dictionaryHeader {
	NSMutableDictionary *dictionary = [[NSMutableDictionary alloc] initWithDictionary:@{
									   @"x-vmob-uid" 						:	[VMUtils uniqueGlobalDeviceIdentifier],
									   @"x-vmob-device_type"				:	[VMUtils deviceType],
									   @"x-vmob-application_version"		: 	[VMUtils applicationVersion],
									   @"x-vmob-device_os_version"			:	[UIDevice currentDevice].systemVersion,
									   @"x-vmob-device"						:	[UIDevice currentDevice].model,
									   @"x-vmob-device_screen_resolution"	:	[VMUtils deviceScreenResolution],
									   @"x-vmob-device_network_type"		:	[VMUtils typeNetworkConnection],
									   @"x-vmob-device_utc_offset"			:	[VMUtils offsetUTC],
									   @"x-vmob-sdk_version"				:	[VMUtils buildVersion]}];
	
	
	[dictionary setObjectOrDoNothing:[VMUtils authorizationKey] forKey:@"x-vmob-authorization"];
	[dictionary setObjectOrDoNothing:[VMUtils currentLatitude]  forKey:@"x-vmob-location_latitude"];
	[dictionary setObjectOrDoNothing:[VMUtils currentLongitude] forKey:@"x-vmob-location_longitude"];
	[dictionary setObjectOrDoNothing:[VMUtils currentAccuracy] forKey:@"x-vmob-location_accuracy"];
	return [self noneCarrierNameWithDictionary:dictionary];
}

- (NSMutableDictionary *) noneCarrierNameWithDictionary: (NSMutableDictionary *) dictionary {
	if (![[VMUtils carrierName] isValid]) {
		[dictionary setObject:@"none" forKey:@"x-vmob-mobile_operator"];
	}
	else {
		[dictionary setObjectOrDoNothing:[VMUtils carrierName] forKey:@"x-vmob-mobile_operator"];
	}
	return dictionary;
}

- (NSMutableDictionary *) dictionaryQueryParam {
	return [NSMutableDictionary new];
}

- (void) processResponse: (NSObject *) response {
	if ([response isKindOfClass:[NSDictionary class]]) {
		self.responseDictionary = (NSDictionary *) response;
	}
}

@end
