//
//  VMCategoriesOfferRequest.m
//  VMobSDK
//
//  Created by vmob.co on 6/1/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "VMCategoriesOfferRequest.h"
#import "NSDictionary+VMValidation.h"
#import "VMUtils.h"

@interface VMCategoriesOfferRequest()
@property (nonatomic, strong) NSMutableDictionary *dictionaryHeader;
@property (nonatomic, strong) NSMutableDictionary *dictionaryQueryParam;
@end

@implementation VMCategoriesOfferRequest

- (VMCategoriesOfferRequest *) initWithUserToken: (NSString *) token
			   includeConsumerExcludedCategories: (BOOL) includeConsumerExcludedCategories {
	if (self = [super init]) {
		self.dictionaryHeader = [super dictionaryHeader];
		[self.dictionaryHeader setObjectOrDoNothing:token forKey:@"Authorization"];
		self.dictionaryQueryParam = [super dictionaryQueryParam];
		[self.dictionaryQueryParam setObjectOrDoNothing:[VMUtils stringWithBOOL:includeConsumerExcludedCategories] forKey:@"includeConsumerExcludedCategories"];
	}
	return self;
}

- (NSString *) path {
	return @"categories";
}

- (NSString *) method {
	return @"GET";
}

@end
