//
//  VMConsumer.h
//  VMobSDK
//
//  Created by vmob.co on 5/31/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "VMConstant.h"

/**
 `VMConsumer` is a class that incapsulates the Consumer personal information.
 */
@interface VMConsumer : NSObject

/**
 Consumer's username.
 */
@property (nonatomic, strong) NSString *userName;

/**
 Consumer's last name.
 */
@property (nonatomic, strong) NSString *lastName;

/**
 Consumer's full name.
 */
@property (nonatomic, strong) NSString *fullName;

/**
 Consumer's first name.
 */
@property (nonatomic, strong) NSString *firstName;

/**
 Consumer's home city.
 */
@property (nonatomic, strong) NSString *homeCity;

/**
 Consumer's email address.
 */
@property (nonatomic, strong) NSString *emailAddress;

/**
 Consumer's date of birth.
 */
@property (nonatomic, strong) NSDate *dateOfBirth;

/**
 Consumer's gender.
 */
@property (nonatomic) VMGender gender;

/**
 Initialize new `VMConsumer` object with dictionary representation.
 
 @param dicitionary Initializing dictionary.
 
 @return A new Consumer object.
 */
- (VMConsumer *) initWithDictionary: (NSDictionary *) dicitionary;

@end
