//
//  VMCrossReferencesRequest.m
//  VMobSDK
//
//  Created by vmob.co on 6/26/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "VMCrossReferencesRequest.h"
#import "NSDictionary+VMValidation.h"

@interface VMCrossReferencesRequest()
@property (nonatomic, strong) NSMutableDictionary *requestDictionary;
@property (nonatomic, strong) NSMutableDictionary *dictionaryHeader;
@end

@implementation VMCrossReferencesRequest

- (VMCrossReferencesRequest *) initCrossReferenceWithToken: (NSString *) token crossReferenceType: (VMCrossReferenceType) crossReferenceType userToken: (NSString *) userToken{
	if (self = [super init]) {
		self.dictionaryHeader = [super dictionaryHeader];
		[self.dictionaryHeader setObjectOrDoNothing:userToken forKey:@"Authorization"];
		
		self.requestDictionary = [NSMutableDictionary dictionary];
		[self.requestDictionary setObject:token forKey:@"externalId"];
		[self.requestDictionary setObject:[NSString stringWithFormat:@"%d",crossReferenceType] forKey:@"systemType"];
	}
	return self;
}

- (NSString *) path {
	return @"crossReferences";
}

@end
