//
//  VMGeoFencesRequest.m
//  VMobSDK
//
//  Created by Ali Darvish on 17/09/13.
//  Copyright (c) 2013 Victor Eysner. All rights reserved.
//

#import "VMGeoFencesRequest.h"
#import "NSDictionary+VMValidation.h"

@interface VMGeoFencesRequest ()
@property (nonatomic, strong) NSMutableDictionary *dictionaryHeader;
@property (nonatomic, strong) NSMutableDictionary *dictionaryQueryParam;
@property (nonatomic, strong) NSString *latitude;
@property (nonatomic, strong) NSString *longitude;
@end

@implementation VMGeoFencesRequest

- (VMGeoFencesRequest *) initWithUserToken:(NSString *)token latitude:(NSString *)latitude longitude:(NSString *)longitude
{
    if(self = [super init])
    {
        self.dictionaryHeader = [super dictionaryHeader];
        [self.dictionaryHeader setObjectOrDoNothing:token forKey:@"Authorization"];
        
        self.dictionaryQueryParam = [super dictionaryQueryParam];
        [self.dictionaryQueryParam setObjectOrDoNothing:latitude forKey:@"latitude"];
		[self.dictionaryQueryParam setObjectOrDoNothing:longitude forKey:@"longitude"];
    }
    
    return self;
}

- (NSString *) method
{
    return @"GET";
}

- (NSString *) path
{
    return @"geofences";
}

- (void) processResponse:(NSArray *)response
{
    [super processResponse:response];
    self.geofences = response;
}

@end
