//
//  VMGiftingCouponsRequest.m
//  VMobSDK
//
//  Created by Ali Darvish on 16/09/13.
//  Copyright (c) 2013 Victor Eysner. All rights reserved.
//

#import "VMGiftingCouponsRequest.h"
#import "NSDictionary+VMValidation.h"

@interface VMGiftingCouponsRequest ()
@property (nonatomic, strong) NSMutableDictionary *dictionaryHeader;
@property (nonatomic, strong) NSString *offerId;
@end

@implementation VMGiftingCouponsRequest

- (VMGiftingCouponsRequest *) initWithUserToken:(NSString *)token offerId: (NSString *) offerId
{
    if(self = [super init])
    {
        self.dictionaryHeader = [super dictionaryHeader];
        [self.dictionaryHeader setObjectOrDoNothing:token forKey:@"Authorization"];
        
        self.offerId = offerId;
    }
    
    return self;
}

- (NSString *) method
{
    return @"GET";
}

- (NSString *) path
{
    return [NSString stringWithFormat:@"giftedoffers/%@", self.offerId];
}

- (void) processResponse: (NSDictionary *) response
{
	[super processResponse:response];
	self.giftedCouponsDictionary = response;
}

@end
