//
//  VMLog.m
//  VMobSDK
//
//  Created by vmob.co on 8/5/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "VMLog.h"
#import "VMUtils.h"

@interface VMLog()
@end

@implementation VMLog

+ (instancetype) instance {
	static dispatch_once_t once;
    static id sharedInstance;
    dispatch_once(&once, ^{
        sharedInstance = [[self alloc] init];
    });
    return sharedInstance;
}

- (id)init {
	if (self = [super init]) {
		self.printLog = [VMUtils printLog];
	}
	return self;
}

+ (NSString*) locationPath {
	NSString* path = [NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) lastObject];
	return [path stringByAppendingPathComponent:@"log.txt"];
}

+ (void) clearLog {
	NSString * content = @"";
	NSString * fileName = [self locationPath];
	[content writeToFile:fileName
			  atomically:NO
				encoding:NSStringEncodingConversionAllowLossy
				   error:nil];
}

+ (NSArray*) logArray {
	NSString * fileName = [self locationPath];
	NSString *content = [NSString stringWithContentsOfFile:fileName
											  usedEncoding:nil error:nil];
	NSMutableArray * array = (NSMutableArray *)[content componentsSeparatedByString:@"\n"];
	NSMutableArray * newArray = [[NSMutableArray alloc] init];
	for (int i = 0; i < [array count]; i++)
	{
		NSString * item = [array objectAtIndex:i];
		if ([item length])
			[newArray addObject:item];
	}
	return (NSArray*)newArray;
}

+ (void) log: (NSString *) msg {
	if (![[self instance] printLog]) {
		return;
	}
	NSLog(@"%@", msg);
	NSString * logMessage = [NSString stringWithFormat:@"%@ %@", [NSDate date], msg];
	NSString * fileName = [self locationPath];
	FILE * f = fopen([fileName cStringUsingEncoding:NSASCIIStringEncoding], "at");
	fprintf(f, "%s\n", [logMessage cStringUsingEncoding:NSASCIIStringEncoding]);
	fclose (f);
}

@end
