//
//  VMLoginRequest.m
//  VMobSDK
//
//  Created by vmob.co on 5/30/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "VMLoginRequest.h"
#import "VMUtils.h"

@interface VMLoginRequest()
@property (nonatomic, strong) NSString *path;
@property (nonatomic, strong) NSDictionary *requestDictionary;
@end

@implementation VMLoginRequest

- (VMLoginRequest *) initWithUserName: (NSString *) userName
							 password: (NSString *) password {
	if (self = [super init]) {
		self.path = @"logins";
		self.requestDictionary = @{
								 @"grant_type":@"password",
								 @"username": userName,
								 @"password": password
			};
	}
	return self;
}

- (VMLoginRequest *) initWithSocialToken: (NSString *) token
							  socialType: (VMSocialType) socialType {
	if (self = [super init]) {
		self.path = @"socialLogins";
		self.requestDictionary = @{
								@"grant_type":@"password",
								@"username": token,
								@"social_source": [VMUtils stringWithSocialToken:socialType],
								@"password": @""
								};
	}
	return self;
}



@end
