//
//  VMMerchantsRequest.m
//  VMobSDK
//
//  Created by vmob.co on 6/1/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "VMMerchantsRequest.h"
#import "NSDictionary+VMValidation.h"

@interface VMMerchantsRequest()
@property (nonatomic, strong) NSMutableDictionary *dictionaryHeader;
@property (nonatomic, strong) NSMutableDictionary *dictionaryQueryParam;
@end

@implementation VMMerchantsRequest

- (VMMerchantsRequest *) initWithUserToken: (NSString *) token
								categoryId: (NSString *) categoryId
									offset: (NSString *) offset
									 limit: (NSString *) limit {
	if (self = [super init]) {
		self.dictionaryHeader = [super dictionaryHeader];
		[self.dictionaryHeader setObjectOrDoNothing:token forKey:@"Authorization"];
		self.dictionaryQueryParam = [super dictionaryQueryParam];
		[self.dictionaryQueryParam setObjectOrDoNothing:categoryId forKey:@"categoryId"];
		[self.dictionaryQueryParam setObjectOrDoNothing:offset forKey:@"offset"];
		[self.dictionaryQueryParam setObjectOrDoNothing:limit forKey:@"limit"];
	}
	return self;
}

- (NSString *) method {
	return @"GET";
}

- (NSString *) path {
	return @"merchants";
}

- (void) processResponse: (NSArray *) response {
	[super processResponse:response];
	self.merchantList = response;
}

@end
