//
//  VMNearbyOffersRequest.m
//  VMobSDK
//
//  Created by vmob.co on 6/3/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "VMNearbyOffersRequest.h"
#import "NSDictionary+VMValidation.h"

@interface VMNearbyOffersRequest ()

@property (nonatomic, strong) NSMutableDictionary *dictionaryHeader;
@property (nonatomic, strong) NSMutableDictionary *dictionaryQueryParam;

@end

@implementation VMNearbyOffersRequest

- (VMNearbyOffersRequest *)initWithUserToken:(NSString *)token
									latitude:(NSString *)lat
								   longitude:(NSString *)lon
								  categoryId:(NSString *)categoryId
									  offset:(NSString *)offset
									   limit:(NSString *)limit
									  fields:(NSString *)fields {
	
	if (self = [super init]) {
		self.dictionaryHeader = [super dictionaryHeader];
		[self.dictionaryHeader setObjectOrDoNothing:token forKey:@"Authorization"];
		self.dictionaryQueryParam = [super dictionaryQueryParam];
		[self.dictionaryQueryParam setObjectOrDoNothing:lat forKey:@"latitude"];
		[self.dictionaryQueryParam setObjectOrDoNothing:lon forKey:@"longitude"];
		[self.dictionaryQueryParam setObjectOrDoNothing:categoryId forKey:@"categoryId"];
		[self.dictionaryQueryParam setObjectOrDoNothing:offset forKey:@"offset"];
		[self.dictionaryQueryParam setObjectOrDoNothing:limit forKey:@"limit"];
		[self.dictionaryQueryParam setObjectOrDoNothing:fields forKey:@"fields"];
	}
	return self;
}

- (NSString *) method {
	return @"GET";
}

- (NSString *) path {
	return @"nearByOffers";
}

- (void) processResponse: (NSArray *) response {
	[super processResponse:response];
	self.offersList = response;
}

@end
