//
//  VMRemoveTagsRequest.m
//  VMobSDK
//
//  Created by vmob.co on 6/17/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "VMRemoveTagsRequest.h"
#import "NSDictionary+VMValidation.h"
#import "VMUtils.h"

@interface VMRemoveTagsRequest()
@property (nonatomic, strong) NSMutableDictionary *requestDictionary;
@property (nonatomic, strong) NSMutableDictionary *dictionaryHeader;
@end

@implementation VMRemoveTagsRequest

- (VMRemoveTagsRequest *) initWithAccessToken: (NSString *) token tagValueReferenceCodes: (NSArray *) tagValueReferenceCodes {
	if (self = [super init]) {
		self.dictionaryHeader = [super dictionaryHeader];
		[self.dictionaryHeader setObjectOrDoNothing:token forKey:@"Authorization"];
		[self.dictionaryHeader setObjectOrDoNothing:[self method] forKey:@"Access-Control-Allow-Methods"];
		self.requestDictionary = [NSMutableDictionary dictionary];
		[self.requestDictionary setObjectOrDoNothing:tagValueReferenceCodes forKey:@"tagValueReferenceCodes"];
	}
	return self;
}

- (NSString *) path {
	return @"consumers/me/tagvalues";
}

- (NSString *) method {
	return @"DELETE";
}

@end
