//
//  VMSearchOffersRequest.m
//  VMobSDK
//
//  Created by vmob.co on 6/3/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "VMSearchOffersRequest.h"
#import "NSDictionary+VMValidation.h"
#import "VMUtils.h"

@interface VMSearchOffersRequest ()

@property (nonatomic, strong) NSMutableDictionary *dictionaryHeader;
@property (nonatomic, strong) NSMutableDictionary *dictionaryQueryParam;

@end

@implementation VMSearchOffersRequest

- (VMSearchOffersRequest *)initWithUserToken:(NSString *)token
								rankedSearch:(BOOL)ranked
									 keyword:(NSString *)keyword
								  categoryId:(NSString *)categoryId
								  merchantId:(NSString *)merchantId
									  fields:(NSString *)fields
									 orderBy:(NSString *)orderBy
								   ascending:(BOOL)ascending {
	
	if (self = [super init]) {
		self.dictionaryHeader = [super dictionaryHeader];
		[self.dictionaryHeader setObjectOrDoNothing:token forKey:@"Authorization"];
		self.dictionaryQueryParam = [super dictionaryQueryParam];
		[self.dictionaryQueryParam setObjectOrDoNothing:[VMUtils stringWithBOOL:ranked] forKey:@"isRankedSearch"];
		[self.dictionaryQueryParam setObjectOrDoNothing:keyword forKey:@"keyword"];
		[self.dictionaryQueryParam setObjectOrDoNothing:categoryId forKey:@"categoryId"];
		[self.dictionaryQueryParam setObjectOrDoNothing:merchantId forKey:@"merchantId"];
		[self.dictionaryQueryParam setObjectOrDoNothing:@"0" forKey:@"offset"];
		[self.dictionaryQueryParam setObjectOrDoNothing:@"100" forKey:@"limit"];
		[self.dictionaryQueryParam setObjectOrDoNothing:fields forKey:@"fields"];
		[self.dictionaryQueryParam setObjectOrDoNothing:orderBy forKey:@"orderBy"];
		[self.dictionaryQueryParam setObjectOrDoNothing:(ascending ? @"asc" : @"desc") forKey:@"orderDirection"];
	}
	return self;
}

- (NSString *) method {
	return @"GET";
}

- (NSString *) path {
	return @"offers";
}

- (void) processResponse: (NSArray *) response {
	[super processResponse:response];
	self.offersList = response;
}

@end
