//
//  VMSendGiftCouponRequest.m
//  VMobSDK
//
//  Created by Ali Darvish on 16/09/13.
//  Copyright (c) 2013 Victor Eysner. All rights reserved.
//

#import "VMSendGiftCouponRequest.h"
#import "NSDictionary+VMValidation.h"

@interface VMSendGiftCouponRequest ()
@property (nonatomic, strong) NSMutableDictionary *dictionaryHeader;
@property (nonatomic, strong) NSMutableDictionary *requestDictionary;
@end

@implementation VMSendGiftCouponRequest

- (VMSendGiftCouponRequest *) initWithUserToken:(NSString *)token offerId:(NSString *)offerId giftedCopy:(NSString *)giftedCopy giftToFriendsId:(NSArray *)giftToFriendsId
{
    if(self = [super init])
    {
        self.dictionaryHeader = [super dictionaryHeader];
        [self.dictionaryHeader setObjectOrDoNothing:token forKey:@"Authorization"];
        
        self.requestDictionary = [NSMutableDictionary new];
        
        NSMutableArray *temp = [NSMutableArray new];
        
        for(NSString *fid in giftToFriendsId)
        {
            [temp addObject:[NSDictionary dictionaryWithObjectsAndKeys:fid, @"externalId", @"3", @"systemType", nil]];
        }
//
//        NSDictionary *recipient = [NSDictionary dictionaryWithObjectsAndKeys:temp, @"recipient", nil];
//        NSDictionary *giftedOffer = [NSDictionary dictionaryWithObjectsAndKeys:offerId, @"offerId", giftedCopy, @"giftedCopy", recipient, @"recipients", nil];
        [self.requestDictionary setObjectOrDoNothing:offerId forKey:@"offerId"];
        [self.requestDictionary setObjectOrDoNothing:giftedCopy forKey:@"giftedCopy"];
        [self.requestDictionary setObjectOrDoNothing:temp forKey:@"recipients"];
    }
    
    return self;
}

- (NSString *) path
{
    return @"giftedoffers";
}

@end
