//
//  VMTermsAndConditionsRequest.m
//  VMobSDK
//
//  Created by vmob.co on 22/07/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "VMTermsAndConditionsRequest.h"
#import "NSDictionary+VMValidation.h"

@interface VMTermsAndConditionsRequest ()
@property (nonatomic, strong) NSMutableDictionary *dictionaryHeader;
@property (nonatomic, strong) NSString *offerId;

@end

@implementation VMTermsAndConditionsRequest

- (VMTermsAndConditionsRequest *) initWithUserToken: (NSString *) token
                                            offerId: (NSString *) offerId {
    
    if (self = [super init]) {
        
        self.dictionaryHeader = [super dictionaryHeader];
        [self.dictionaryHeader setObjectOrDoNothing:token forKey:@"Authorization"];
        
        self.offerId = offerId;
        
    }
    
    return self;
}


- (NSString *) method {
	return @"GET";
}

- (NSString *) path {
	return [NSString stringWithFormat:@"offers/%@/termsAndConditions", self.offerId];;
}

- (void) processResponse: (NSDictionary *) response {
	[super processResponse:response];
	self.termsAndConditionsDictionary = response;
}

@end
