//
//  VMAddTagRequest.m
//  VMobSDK
//
//  Created by vmob.co on 6/17/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import "VMUpdateTagsRequest.h"
#import "NSDictionary+VMValidation.h"

@interface VMUpdateTagsRequest()
@property (nonatomic, strong) NSMutableDictionary *requestDictionary;
@property (nonatomic, strong) NSMutableDictionary *dictionaryHeader;
@end

@implementation VMUpdateTagsRequest

- (VMUpdateTagsRequest *) initWithAccessToken: (NSString *) token
					tagValueAddReferenceCodes: (NSArray *) tagValueAddReferenceCodes
				 tagValueRemoveReferenceCodes: (NSArray *) tagValueRemoveReferenceCodes {
	if (self = [super init]) {
		self.dictionaryHeader = [super dictionaryHeader];
		[self.dictionaryHeader setObjectOrDoNothing:token forKey:@"Authorization"];
		self.requestDictionary = [NSMutableDictionary dictionary];
		[self.requestDictionary setObjectOrDoNothing:tagValueAddReferenceCodes forKey:@"tagValueAddReferenceCodes"];
		[self.requestDictionary setObjectOrDoNothing:tagValueRemoveReferenceCodes forKey:@"tagValueRemoveReferenceCodes"];
	}
	return self;
}

- (NSString *) method {
	return @"PUT";
}

- (NSString *) path {
	return @"consumers/me/tagvalues";
}
@end
