//
//  Utils.h
//  VMobSDK
//
//  Created by vmob.co on 5/29/13.
//  Copyright (c) 2013 vmob.co. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <CoreLocation/CoreLocation.h>
#import "VMConstant.h"

#define kBundleIdentifier [[NSBundle mainBundle] objectForInfoDictionaryKey:(NSString*)kCFBundleIdentifierKey]
#define kIsPad (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)

@interface VMUtils : NSObject
@property (nonatomic, strong) CLLocation *currentLocation;

#pragma mark - Other Methods

+ (VMGender) grenderTypeWithString: (NSString *) string;
+ (NSString *) stringWithBOOL: (BOOL) value;
+ (NSString *) stringWithSocialToken:(VMSocialType) socialType;
+ (NSString *) stringWithGrenderType: (VMGender) gender;
+ (NSMutableArray *) arraWithInvoke: (NSObject *) object withParameters: (va_list) args  ;
+ (NSString *) UTCFormateDate: (NSDate *) date;
+ (NSDate *) dateUTCString: (NSString *) date;
+ (NSDateFormatter *) UTCFormater;
+ (void) setCLLocation: (CLLocation *) location;
+ (instancetype) sharedInstance;

#pragma mark - Header Helper

+ (NSString *) deviceType;
+ (NSString *) applicationVersion;
+ (NSString *) deviceScreenResolution;
+ (NSString *) carrierName;
+ (NSString *) offsetUTC;
+ (NSString *) typeNetworkConnection;
+ (NSString *) currentLatitude;
+ (NSString *) currentLongitude;
+ (NSString *) currentAccuracy;

#pragma mark - BaseURL API

+ (NSString *) configurationApiUrl;
+ (NSString *) activityApiUrl;
+ (NSString *) consumerApiUrl;
+ (NSString *) locationApiUrl;
+ (NSString *) offerApiUrl;

#pragma mark - User Constant

+ (BOOL) printLog;
+ (NSString *) buildVersion;
+ (NSString *) uniqueGlobalDeviceIdentifier;
+ (NSString *) authorizationKey;

+ (NSTimeInterval) activitiesSendMinTimerInSeconds;
+ (NSInteger) activitiesBatchSize;
+ (NSUInteger) activitiesExpireSize;
+ (NSTimeInterval) activitiesExpireAgeInSeconds;

+ (NSTimeInterval) gpsBackgroundMinIntervalInSeconds;
+ (NSTimeInterval) updateLocationTimeInterval;
+ (double) locationAccuracy;
+ (double) locationDistanceFilter;

#pragma mark - Configuration Methods

+ (BOOL) addCodeForAutoConfgurationUpdate; 
+ (BOOL) isUpdateConfiguration;
+ (NSDate *) lastUpdateConfiguration;
+ (void) updateConfiguration;

@end
